/***************************************************************************
 *   Copyright (C) 2004 by Stephen Anthony                                 *
 *   stephena@users.sourceforge.net                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GAMELIST_H
#define GAMELIST_H

#include "game.h"


/**
	Holds the list of game objects.  Basically a resizable array.
*/
class GameList
{
	public:
		GameList( void );
		~GameList( void );

		/** Insert the given game  */
		void insert( Game* game );

		/** Delete all games in the list */
		void clear( void );

		/** Return the game at the specified index */
		Game* at( int index );

		/** Return the size of the game list */
		int size( void );

	private:
		int listSize;
		int index;
		Game** list;
};

#endif
