/***************************************************************************
 *   Copyright (C) 2004 by Stephen Anthony                                 *
 *   stephena@users.sourceforge.net                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "preview.h"


Preview::Preview( QWidget* parent )
		: QFrame( parent, "preview" )
{
	setMinimumSize( 200, 100 );
}


Preview::~Preview()
{
}


void Preview::setPixmap( const QPixmap& pixmap)
{
	myBuffer = pixmap;
	repaint();
}

void Preview::paintEvent( QPaintEvent* e )
{
	int posx = (contentsRect().width() - myBuffer.width() - 8) / 2;
	int posy = (contentsRect().height() - myBuffer.height() - 8) / 2;
	posx = posx < 0 ? -posx : posx;
	posy = posy < 0 ? -posy : posy;

	bitBlt( this, posx, posy, &myBuffer );
	QFrame::paintEvent( e );
}
