/***************************************************************************
 *   Copyright (C) 2004 by Stephen Anthony                                 *
 *   stephena@users.sourceforge.net                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

using namespace std;

#include <iostream>

#include <klocale.h>
#include <kconfig.h>
#include <kapplication.h>

#include <qlayout.h>
#include <qtabwidget.h>
#include <qtextbrowser.h>
#include <qpixmap.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qtimer.h>
#include <qfile.h>
#include <qimage.h>
#include <qframe.h>

#include "previewwindow.h"

// shamelessly ripped from the qmamecat frontend :)
static const char* no_preview_xpm[] =
{
	"161 133 1257 2", "  	c None",
	". 	c #696969","+ 	c #6B6B6B","@ 	c #6D6D6D","# 	c #6E6E6E","$ 	c #6F6F6F",	"% 	c #707070","& 	c #717171","* 	c #727272","= 	c #737373","- 	c #747474","; 	c #757575","> 	c #767676",", 	c #777777","' 	c #787878",") 	c #797979",	"! 	c #7A7A7A","~ 	c #7B7B7B","{ 	c #7C7C7C","] 	c #7D7D7D","^ 	c #7E7E7E",
	"/ 	c #7F7F7F","( 	c #808080","_ 	c #818181",": 	c #814C4C","< 	c #820000",	"[ 	c #810000","} 	c #800000","| 	c #7F0000","1 	c #7E0000","2 	c #7D0000","3 	c #828282","4 	c #838383","5 	c #848484","6 	c #842727","7 	c #840000",	"8 	c #830000","9 	c #7C0000","0 	c #7B0000","a 	c #858585","b 	c #868686",
	"c 	c #862E2E","d 	c #860000","e 	c #850000","f 	c #7A0000","g 	c #790000",	"h 	c #878787","i 	c #888888","j 	c #888080","k 	c #880101","l 	c #880000","m 	c #870000","n 	c #780000","o 	c #898989","p 	c #8A8A8A","q 	c #8B8B8B",	"r 	c #8B3E3E","s 	c #8B0000","t 	c #8A0000","u 	c #890000","v 	c #770000",
	"w 	c #8C8C8C","x 	c #8D8D8D","y 	c #8D6D6D","z 	c #8D0000","A 	c #8C0000",	"B 	c #760000","C 	c #8E8E8E","D 	c #8F8F8F","E 	c #909090","F 	c #900202","G 	c #900000","H 	c #8F0000","I 	c #8E0000","J 	c #750000","K 	c #919191",	"L 	c #929292","M 	c #922525","N 	c #920000","O 	c #910000","P 	c #740000",
	"Q 	c #939393","R 	c #949494","S 	c #959595","T 	c #955C5C","U 	c #940000",	"V 	c #930000","W 	c #730000","X 	c #969696","Y 	c #979797","Z 	c #978F8F","` 	c #970000"," .	c #960000","..	c #950000","+.	c #989898","@.	c #999999",	"#.	c #9A9A9A","$.	c #990E0E","%.	c #990000","&.	c #980000","*.	c #720000",
	"=.	c #9B9B9B","-.	c #9C9C9C",";.	c #9C2E2E",">.	c #9C0000",",.	c #9B0000",	"'.	c #9A0000",").	c #710000","!.	c #9D9D9D","~.	c #9E9E9E","{.	c #9E7878","].	c #9E0000","^.	c #9D0000","/.	c #8E8B8B","(.	c #9F9F9F","_.	c #A0A0A0",	":.	c #A1A1A1","<.	c #A19999","[.	c #A00000","}.	c #9F0000","|.	c #907878",
	"1.	c #A2A2A2","2.	c #A3A3A3","3.	c #A30F0F","4.	c #A30000","5.	c #A20000",	"6.	c #A10000","7.	c #700000","8.	c #900303","9.	c #928D8D","0.	c #A4A4A4","a.	c #A5A5A5","b.	c #A6A6A6","c.	c #A53232","d.	c #A50000","e.	c #A40000",	"f.	c #6F0000","g.	c #926B6B","h.	c #A7A7A7","i.	c #A8A8A8","j.	c #A88484",
	"k.	c #A70000","l.	c #A60000","m.	c #924545","n.	c #A9A9A9","o.	c #AAAAAA",	"p.	c #ABABAB","q.	c #AA1111","r.	c #AA0000","s.	c #A90000","t.	c #A80000","u.	c #924242","v.	c #ACACAC","w.	c #ADADAD","x.	c #AC6F6F","y.	c #AC0000",	"z.	c #AB0000","A.	c #931212","B.	c #959090","C.	c #AEAEAE","D.	c #AFAFAF",
	"E.	c #B0B0B0","F.	c #AFA7A7","G.	c #AE0303","H.	c #AE0000","I.	c #AD0000",	"J.	c #6E0000","K.	c #956F6F","L.	c #B1B1B1","M.	c #B2B2B2","N.	c #941414","O.	c #B3B3B3","P.	c #B4B4B4","Q.	c #B5B5B5","R.	c #6D0000","S.	c #966E6E",	"T.	c #B6B6B6","U.	c #B7B7B7","V.	c #6C0000","W.	c #989494","X.	c #B8B8B8",
	"Y.	c #B9B9B9","Z.	c #982828","`.	c #BABABA"," +	c #BBBBBB",".+	c #BCBCBC", "++	c #997171","@+	c #BDBDBD","#+	c #BEBEBE","$+	c #6B0000","%+	c #9B9090","&+	c #BFBFBF","*+	c #C0C0C0","=+	c #C1C1C1","-+	c #C2C2C2",";+	c #C3C3C3", ">+	c #930303",",+	c #912E2E","'+	c #8F0D0D",")+	c #9B0505","!+	c #C4C4C4",
	"~+	c #C5C5C5","{+	c #C6C6C6","]+	c #940F0F","^+	c #928484","/+	c #904545", "(+	c #9D3838","_+	c #C7C7C7",":+	c #C8C8C8","<+	c #A6A3A3","[+	c #960101","}+	c #945151","|+	c #918181","1+	c #8F0F0F","2+	c #6A0000","3+	c #9E0B0B", "4+	c #C9C9C9","5+	c #CACACA","6+	c #CBCBCB","7+	c #A99797","8+	c #A70B0B",
	"9+	c #990101","0+	c #972B2B","a+	c #956060","b+	c #939292","c+	c #904D4D", "d+	c #8E0101","e+	c #CCCCCC","f+	c #CDCDCD","g+	c #AD6B6B","h+	c #9A3A3A","i+	c #988C8C","j+	c #966666","k+	c #947878","l+	c #928585","m+	c #8F1212", "n+	c #CECECE","o+	c #CFCFCF","p+	c #B2AFAF","q+	c #B02F2F","r+	c #9E0909",
	"s+	c #9B8383","t+	c #994444","u+	c #970101","v+	c #950C0C","w+	c #937A7A", "x+	c #905151","y+	c #A48989","z+	c #D0D0D0","A+	c #D1D1D1","B+	c #D2D2D2","C+	c #B5A0A0","D+	c #B30B0B","E+	c #B10000","F+	c #AF0000","G+	c #A30202","H+	c #9F1919","I+	c #9D9393","J+	c #9A1C1C","K+	c #945757","L+	c #918888",
	"M+	c #8F1717","N+	c #690000","O+	c #D3D3D3","P+	c #D4D4D4","Q+	c #B97070","R+	c #B70000","S+	c #B50000","T+	c #B30000","U+	c #A80202","V+	c #A63737","W+	c #A47070","X+	c #A23B3B","Y+	c #A01616","Z+	c #9E9595","`+	c #9B3232"," @	c #970303",".@	c #956969","+@	c #928282","@@	c #903030","#@	c #A99F9F",
	"$@	c #D5D5D5","%@	c #D6D6D6","&@	c #D7D7D7","*@	c #BEBBBB","=@	c #BC3030","-@	c #BA0000",";@	c #B80000",">@	c #B60000",",@	c #B40000","'@	c #B20000",")@	c #B00000","!@	c #AC0404","~@	c #AA3333","{@	c #A79999","]@	c #A58E8E","^@	c #A39C9C","/@	c #A12C2C","(@	c #9F7777","_@	c #9C8686",":@	c #9A4141",
	"<@	c #985A5A","[@	c #967C7C","}@	c #931919","|@	c #910202","1@	c #680000","2@	c #AA6969","3@	c #D8D8D8","4@	c #D9D9D9","5@	c #C2A8A8","6@	c #C00A0A","7@	c #BE0000","8@	c #BC0000","9@	c #B90000","0@	c #AF0202","a@	c #AD5858","b@	c #AB9A9A","c@	c #A84848","d@	c #A60F0F","e@	c #A47979","f@	c #A27373",
	"g@	c #A02121","h@	c #9D7F7F","i@	c #9B9393","j@	c #997E7E","k@	c #972626","l@	c #6A1010","m@	c #685C5C","n@	c #666666","o@	c #636363","p@	c #616161","q@	c #AB0A0A","r@	c #ADABAB","s@	c #DADADA","t@	c #DBDBDB","u@	c #DCDCDC","v@	c #C57474","w@	c #C30000","x@	c #C10000","y@	c #BF0000","z@	c #BD0000",
	"A@	c #BB0000","B@	c #B22020","C@	c #B02C2C","D@	c #AE4E4E","E@	c #ACA9A9","F@	c #AA3232","G@	c #A52828","H@	c #A39B9B","I@	c #A13030","J@	c #9E0808","K@	c #9C1717","L@	c #9A0909","M@	c #701111","N@	c #6D5A5A","O@	c #646464","P@	c #AE2C2C","Q@	c #B1AEAE","R@	c #DDDDDD","S@	c #DEDEDE","T@	c #CAC6C6",
	"U@	c #C83030","V@	c #C60000","W@	c #C40000","X@	c #C20000","Y@	c #C00000","Z@	c #B60101","`@	c #B37272"," #	c #B18F8F",".#	c #AF1818","+#	c #AD9292","@#	c #AB6B6B","##	c #A80101","$#	c #A60303","%#	c #A46F6F","&#	c #A17373","*#	c #9F0101","=#	c #751212","-#	c #735F5F",";#	c #6C6C6C",">#	c #676767",
	",#	c #B12C2C","'#	c #B4B1B1",")#	c #DFDFDF","!#	c #E0E0E0","~#	c #E1E1E1","{#	c #CEB1B1","]#	c #CC0A0A","^#	c #CA0000","/#	c #C80000","(#	c #BB0909","_#	c #B90D0D",":#	c #B42A2A","<#	c #B2A9A9","[#	c #B04444","}#	c #AE4949","|#	c #ABA1A1","1#	c #A92323","2#	c #A51B1B","3#	c #A22626","4#	c #A00101",
	"5#	c #7A0808","6#	c #785454","7#	c #6A6A6A","8#	c #656565","9#	c #B20707","0#	c #B47373","a#	c #E2E2E2","b#	c #E3E3E3","c#	c #D17777","d#	c #CF0000","e#	c #CD0000","f#	c #CB0000","g#	c #C90000","h#	c #C70000","i#	c #C50000","j#	c #BE0202","k#	c #BC6A6A","l#	c #BA7171","m#	c #B80101","n#	c #B50202",
	"o#	c #B19393","p#	c #AC9090","q#	c #AA6F6F","r#	c #800101","s#	c #7D3636","t#	c #6A6969","u#	c #682121","v#	c #B15252","w#	c #B3AFAF","x#	c #E4E4E4","y#	c #E5E5E5","z#	c #D7D2D2","A#	c #D53030","B#	c #D30000","C#	c #D10000","D#	c #CE0000","E#	c #CC0000","F#	c #C40101","G#	c #C20202","H#	c #BF0101",
	"I#	c #BD4545","J#	c #BBB0B0","K#	c #B92727","L#	c #B42B2B","M#	c #B2AEAE","N#	c #AF4D4D","O#	c #AD3C3C","P#	c #AB5050","Q#	c #A80303","R#	c #831717","S#	c #807777","T#	c #6D6464","U#	c #6B1212","V#	c #670000","W#	c #AD0707","X#	c #AF8383","Y#	c #E6E6E6","Z#	c #E7E7E7","`#	c #E8E8E8"," $	c #DABABA",
	".$	c #D81C1C","+$	c #D60000","@$	c #D40000","#$	c #D20000","$$	c #D00000","%$	c #C70C0C","&$	c #C56161","*$	c #C28F8F","=$	c #C07171","-$	c #BE2020",";$	c #BC9292",">$	c #B97B7B",",$	c #B70303","'$	c #B52121",")$	c #B3ABAB","!$	c #B08383","~$	c #AE0707","{$	c #AC0202","]$	c #9B0C0C","^$	c #8D0202",
	"/$	c #8A1414","($	c #882121","_$	c #857070",":$	c #704D4D","<$	c #6D0707","[$	c #660000","}$	c #AE8A8A","|$	c #E9E9E9","1$	c #EAEAEA","2$	c #DD8686","3$	c #DB0909","4$	c #D90000","5$	c #D70000","6$	c #D50000","7$	c #D12020","8$	c #CF3939","9$	c #CA0606","0$	c #C88080","a$	c #C6ACAC","b$	c #C38383",
	"c$	c #C1B0B0","d$	c #BF9292","e$	c #BAB5B5","f$	c #B87474","g$	c #B68A8A","h$	c #B36C6C","i$	c #B11F1F","j$	c #9E3838","k$	c #928E8E","l$	c #8F7676","m$	c #757474","n$	c #734141","o$	c #AC6161","p$	c #EBEBEB","q$	c #ECECEC","r$	c #EDEDED","s$	c #E3DDDD","t$	c #E14848","u$	c #DF0000","v$	c #DD0000",
	"w$	c #DB0000","x$	c #D40303","y$	c #D28F8F","z$	c #D09090","A$	c #CD0303","B$	c #CB3131","C$	c #C9B5B5","D$	c #C62020","E$	c #C23C3C","F$	c #C0B6B6","G$	c #BD3131","H$	c #BB6666","I$	c #B9A7A7","J$	c #B67C7C","K$	c #B41010","L$	c #A16060","M$	c #787777","N$	c #752121","O$	c #650000","P$	c #AA2828",
	"Q$	c #EEEEEE","R$	c #EFEFEF","S$	c #E6C2C2","T$	c #E41C1C","U$	c #E20000","V$	c #E00000","W$	c #DE0000","X$	c #DC0000","Y$	c #DA0000","Z$	c #D50606","`$	c #D3ACAC"," %	c #D08D8D",".%	c #CE3F3F","+%	c #CC5656","@%	c #C99D9D","#%	c #C70303","$%	c #C21010","%%	c #C0AEAE","&%	c #BE3535","*%	c #BB0202",
	"=%	c #B91010","-%	c #B70606",";%	c #A37A7A",">%	c #7A6E6E",",%	c #780808","'%	c #A80808",")%	c #AAA7A7","!%	c #F0F0F0","~%	c #F1F1F1","{%	c #F2F2F2","]%	c #EA8989","^%	c #E80909","/%	c #E60000","(%	c #E30000","_%	c #E10000",":%	c #D80000","<%	c #D60202","[%	c #D49494","}%	c #D1D0D0","|%	c #CF6B6B",
	"1%	c #CD5656","2%	c #CAB4B4","3%	c #C81515","4%	c #C32A2A","5%	c #C1AEAE","6%	c #BE1D1D","7%	c #A90F0F","8%	c #A69A9A","9%	c #7D5959","0%	c #A89292","a%	c #F3F3F3","b%	c #F4F4F4","c%	c #EFE8E8","d%	c #ED4848","e%	c #EB0000","f%	c #E90000","g%	c #E70000","h%	c #E40000","i%	c #D70303","j%	c #D47C7C",
	"k%	c #D2C8C8","l%	c #CF6666","m%	c #CD2121","n%	c #CBBCBC","o%	c #C89696","p%	c #C66262","q%	c #C4A3A3","r%	c #C17575","s%	c #BF0202","t%	c #AC2020","u%	c #7D0A0A","v%	c #A66060","w%	c #F5F5F5","x%	c #F6F6F6","y%	c #F7F7F7","z%	c #F2CACA","A%	c #F01C1C","B%	c #EE0000","C%	c #EC0000","D%	c #EA0000",
	"E%	c #E80000","F%	c #E50000","G%	c #D50707","H%	c #D27777","I%	c #D0BBBB","J%	c #CE1818","K%	c #CB4747","L%	c #C9A4A4","M%	c #C6ADAD","N%	c #C47070","O%	c #C20E0E","P%	c #AE5C5C","Q%	c #686868","R%	c #606060","S%	c #5E5E5E","T%	c #5B5B5B","U%	c #595959","V%	c #575757","W%	c #A42929","X%	c #F8F8F8",
	"Y%	c #F9F9F9","Z%	c #F68C8C","`%	c #F40808"," &	c #F20000",".&	c #EF0000","+&	c #ED0000","@&	c #E10404","#&	c #DF0A0A","$&	c #DC0202","%&	c #D31D1D","&&	c #CE6B6B","*&	c #CC0101","=&	c #C90808","-&	c #C70D0D",";&	c #C40202",">&	c #B16F6F",",&	c #5C5C5C","'&	c #545454",")&	c #535353","!&	c #A11A1A",
	"~&	c #A4A1A1","{&	c #FAFAFA","]&	c #FBFBFB","^&	c #FBF3F3","/&	c #F94747","(&	c #F70000","_&	c #F50000",":&	c #F00000","<&	c #E42525","[&	c #E29898","}&	c #DFBFBF","|&	c #DD9090","1&	c #DA1616","2&	c #D30101","3&	c #D16C6C","4&	c #CEB9B9","5&	c #CC1616","6&	c #B60404","7&	c #B3A8A8","8&	c #A28585",
	"9&	c #FDD0D0","0&	c #FC1B1B","a&	c #FA0000","b&	c #F80000","c&	c #F30000","d&	c #E71212","e&	c #E4B7B7","f&	c #E2A3A3","g&	c #DF6868","h&	c #DDC9C9","i&	c #DA8686","j&	c #D80101","k&	c #D11919","l&	c #CE6363","m&	c #CC0909","n&	c #B81B1B","o&	c #B5AAAA","p&	c #9F3E3E","q&	c #FB8B8B","r&	c #FC0808",
	"s&	c #FC0000","t&	c #EB0101","u&	c #E75757","v&	c #E4BBBB","w&	c #E21919","x&	c #DF6E6E","y&	c #DA7272","z&	c #D80D0D","A&	c #CE0101","B&	c #BB2727","C&	c #565656","D&	c #585858","E&	c #5D5D5D","F&	c #9C1A1A","G&	c #9F9C9C","H&	c #F6EDED","I&	c #F84343","J&	c #F90000","K&	c #F60000","L&	c #F40000",
	"M&	c #ED0C0C","N&	c #EB6B6B","O&	c #E91818","P&	c #E67E7E","Q&	c #E4B0B0","R&	c #E19797","S&	c #DFC0C0","T&	c #DD5353","U&	c #DA9D9D","V&	c #D82C2C","W&	c #BD7777","X&	c #6A4F4F","Y&	c #684D4D","Z&	c #654B4B","`&	c #635353"," *	c #626262",".*	c #9A0808","+*	c #9D8A8A","@*	c #F2C4C4","#*	c #F41919",
	"$*	c #F10101","%*	c #EF2F2F","&*	c #EC7171","**	c #EAE0E0","=*	c #E87171","-*	c #E67171",";*	c #E3E2E2",">*	c #E1B0B0",",*	c #DE2727","'*	c #DC5050",")*	c #DABEBE","!*	c #D71212","~*	c #C20505","{*	c #BFA5A5","]*	c #764646","^*	c #741A1A","/*	c #640000","(*	c #5F5F5F","_*	c #9A6262",":*	c #EFA7A7",
	"<*	c #F10707","[*	c #F10000","}*	c #EF4D4D","|*	c #EDD6D6","1*	c #EBBDBD","2*	c #E9D2D2","3*	c #E7CBCB","4*	c #E54040","5*	c #E2CECE","6*	c #E0BFBF","7*	c #DE9090","8*	c #DBC7C7","9*	c #D95F5F","0*	c #D70101","a*	c #C41616","b*	c #C1B6B6","c*	c #766161","d*	c #740707","e*	c #630000","f*	c #5A5A5A",
	"g*	c #970909","h*	c #9A9898","i*	c #E9E1E1","j*	c #EB6161","k*	c #EF0E0E","l*	c #EEC2C2","m*	c #EC7979","n*	c #EA0707","o*	c #E82D2D","p*	c #E6D4D4","q*	c #E47979","r*	c #E23C3C","s*	c #DF9C9C","t*	c #DDA1A1","u*	c #DB5050","v*	c #D80404","w*	c #C62E2E","x*	c #747373","y*	c #714242","z*	c #6F0707",
	"A*	c #978686","B*	c #E6CACA","C*	c #E82525","D*	c #F01B1B","E*	c #EF2E2E","F*	c #ED2929","G*	c #ECDBDB","H*	c #EA2B2B","I*	c #E70202","J*	c #E5A0A0","K*	c #E3CDCD","L*	c #E01D1D","M*	c #DE0303","N*	c #DC0303","O*	c #C77B7B","P*	c #6C5A5A","Q*	c #6A1111","R*	c #8D8686","S*	c #8F6F6F","T*	c #924646",
	"U*	c #944646","V*	c #E39B9B","W*	c #E50606","X*	c #EE0202","Y*	c #EE2222","Z*	c #ED9292","`*	c #ECB8B8"," =	c #EB2E2E",".=	c #EADBDB","+=	c #E94646","@=	c #E50707","#=	c #E3AAAA","$=	c #E1D7D7","%=	c #CC0606","&=	c #C98F8F","*=	c #675656","==	c #641010","-=	c #DDD4D4",";=	c #DF5959",">=	c #EB0505",
	",=	c #EB7474","'=	c #EBD6D6",")=	c #EBD9D9","!=	c #EAE7E7","~=	c #E96161","{=	c #E8B1B1","]=	c #E7BEBE","^=	c #E54C4C","/=	c #E37E7E","(=	c #E2B5B5","_=	c #E09393",":=	c #DE9393","<=	c #CD0707","[=	c #CAC1C1","}=	c #8B7B7B","|=	c #886262","1=	c #866060","2=	c #845F5F","3=	c #815D5D","4=	c #7F6B6B",
	"5=	c #DABDBD","6=	c #DC2020","7=	c #E94545","8=	c #E9D3D3","9=	c #E94949","0=	c #E81F1F","a=	c #E89C9C","b=	c #E7BCBC","c=	c #E64141","d=	c #E5BEBE","e=	c #E3DCDC","f=	c #E2BDBD","g=	c #E04040","h=	c #DE9999","i=	c #DC7C7C","j=	c #CE3333","k=	c #CCC4C4","l=	c #8A3232","m=	c #7A1212","n=	c #773030",
	"o=	c #755656","p=	c #D68F8F","q=	c #D80505","r=	c #E60101","s=	c #E68A8A","t=	c #E69A9A","u=	c #E60202","v=	c #E53131","w=	c #E5DCDC","x=	c #E45E5E","y=	c #E31212","z=	c #E13C3C","A=	c #E04B4B","B=	c #DE7777","C=	c #DDC3C3","D=	c #DB2A2A","E=	c #CF4848","F=	c #8A3838","G=	c #701010","H=	c #6D3E3E",
	"I=	c #6B6363","J=	c #D1C8C8","K=	c #D35151","L=	c #E10606","M=	c #E23D3D","N=	c #E33E3E","O=	c #E30606","P=	c #E49595","Q=	c #E49B9B","R=	c #E40202","S=	c #E33030","T=	c #E2DADA","U=	c #E1B5B5","V=	c #E00E0E","W=	c #DF8585","X=	c #DED4D4","Y=	c #DCB8B8","Z=	c #DB4444","`=	c #CF9494"," -	c #893737",
	".-	c #650E0E","+-	c #631515","@-	c #D01C1C","#-	c #DE0606","$-	c #DF8282","%-	c #E0D7D7","&-	c #E0DBDB","*-	c #E16363","=-	c #E16464","--	c #E1D0D0",";-	c #E14242",">-	c #E12121",",-	c #E19999","'-	c #E08686",")-	c #DF3A3A","!-	c #DE0101","~-	c #DD1212","{-	c #DC2C2C","]-	c #DA0F0F","^-	c #D90101",
	"/-	c #D30808","(-	c #D0BABA","_-	c #555555",":-	c #CA8383","<-	c #CC0404","[-	c #DB1010","}-	c #DC4040","|-	c #DDC1C1","1-	c #DD4040","2-	c #DE8989","3-	c #DFC9C9","4-	c #DF3333","5-	c #DFB0B0","6-	c #DFD9D9","7-	c #DFD1D1","8-	c #DEAFAF","9-	c #DE1B1B","0-	c #D22222","a-	c #D0C8C8","b-	c #883737",
	"c-	c #620000","d-	c #B2A8A8","e-	c #B48989","f-	c #C5BBBB","g-	c #C74949","h-	c #D10101","i-	c #D74545","j-	c #D8B9B9","k-	c #D9CDCD","l-	c #DA9B9B","m-	c #DB0202","n-	c #DC1A1A","o-	c #DCC1C1","p-	c #DC7878","q-	c #DC1616","r-	c #DC5858","s-	c #DC5454","t-	c #DC1414","u-	c #D23C3C","v-	c #873636",
	"w-	c #AF5050","x-	c #B10303","y-	c #C1A5A5","z-	c #C31919","A-	c #CE0C0C","B-	c #D06868","C-	c #D11717","D-	c #D30606","E-	c #D44444","F-	c #D5B5B5","G-	c #D67D7D","H-	c #D7A7A7","I-	c #D8C0C0","J-	c #D91616","K-	c #DA6B6B","L-	c #DAC7C7","M-	c #DA2121","N-	c #D18E8E","O-	c #860606",
	"P-	c #A9A0A0","Q-	c #AB2020","R-	c #BE0D0D","S-	c #C00303","T-	c #CC1818","U-	c #CEA4A4","V-	c #CF3232","W-	c #D12222","X-	c #D2C2C2","Y-	c #D3A0A0","Z-	c #D40404","`-	c #D52626"," ;	c #D6C3C3",".;	c #D66868","+;	c #D71616","@;	c #D78C8C","#;	c #D20909","$;	c #D19F9F","%;	c #610000",
	"&;	c #A69C9C","*;	c #A81212","=;	c #CC2828","-;	c #CD8B8B",";;	c #CE2020",">;	c #D08989",",;	c #D1B2B2","';	c #D21010",");	c #D37373","!;	c #D4BCBC","~;	c #D41B1B","{;	c #D50404","];	c #D10A0A","^;	c #D0C9C9","/;	c #888181","(;	c #A39898","_;	c #A51111",":;	c #CA1414","<;	c #CBB3B3",
	"[;	c #CC7575","};	c #CD2E2E","|;	c #CEC1C1","1;	c #CF5555","2;	c #D11D1D","3;	c #D2AEAE","4;	c #D23333","5;	c #D03E3E","6;	c #CFC9C9","7;	c #877979","8;	c #9F7C7C","9;	c #A10202","0;	c #C80101","a;	c #C96060","b;	c #CABDBD","c;	c #CB2323","d;	c #CC8080","e;	c #CDAEAE","f;	c #CE1111",
	"g;	c #CF1515","h;	c #D00202","i;	c #CE5D5D","j;	c #865454","k;	c #9E9898","l;	c #C71313","m;	c #C8AAAA","n;	c #C97979","o;	c #CA2828","p;	c #CBBBBB","q;	c #CC4444","r;	c #CC9C9C","s;	c #853535","t;	c #8A0505","u;	c #8C5F5F","v;	c #BB0303","w;	c #BD4040","x;	c #BE7878","y;	c #BF6B6B",
	"z;	c #C11C1C","A;	c #C65858","B;	c #C7BABA","C;	c #C82828","D;	c #C93636","E;	c #C90A0A","F;	c #CB0B0B","G;	c #CAB9B9","H;	c #831616","I;	c #600000","J;	c #8D4C4C","K;	c #B95252","L;	c #BBADAD","M;	c #BC8E8E","N;	c #BDAFAF","O;	c #BF9B9B","P;	c #C01212","Q;	c #C41010","R;	c #C48E8E",
	"S;	c #C52C2C","T;	c #C92727","U;	c #C8C3C3","V;	c #858383","W;	c #8E2727","X;	c #908D8D","Y;	c #B61313","Z;	c #B7A2A2","`;	c #B93E3E"," >	c #BA0303",".>	c #BB2C2C","+>	c #BDB2B2","@>	c #BE4242","#>	c #C20909","$>	c #C30101","%>	c #C74444","&>	c #847676","*>	c #8E1B1B","=>	c #918E8E",
	"->	c #B10101",";>	c #B43030",">>	c #B70E0E",",>	c #B90505","'>	c #BB9898",")>	c #BC5454","!>	c #C49090","~>	c #822E2E","{>	c #8F1B1B","]>	c #977B7B","^>	c #AC0505","/>	c #AD4B4B","(>	c #AF7474","_>	c #B02A2A",":>	c #B23232","<>	c #B51F1F","[>	c #B70F0F","}>	c #B9A0A0","|>	c #BA3737",
	"1>	c #C20B0B","2>	c #C19C9C","3>	c #848181","4>	c #901A1A","5>	c #928F8F","6>	c #963636","7>	c #A80606","8>	c #AA4B4B","9>	c #AB9C9C","0>	c #AD9C9C","a>	c #AE9797","b>	c #B02424","c>	c #B19A9A","d>	c #B38888","e>	c #B44545","f>	c #B57D7D","g>	c #B68D8D","h>	c #B70C0C","i>	c #BF0C0C",
	"j>	c #BFBABA","k>	c #825050","l>	c #900404","m>	c #921616","n>	c #940202","o>	c #A50606","p>	c #A66F6F","q>	c #A89898","r>	c #A92A2A","s>	c #AB1A1A","t>	c #AC9A9A","u>	c #AF3A3A","v>	c #B19595","w>	c #B2A7A7","x>	c #B38484","y>	c #B41D1D","z>	c #BC4343","A>	c #BCB9B9","B>	c #810505",
	"C>	c #A46B6B","D>	c #A69D9D","E>	c #A81515","F>	c #AA4A4A","G>	c #AC9C9C","H>	c #AD1717","I>	c #AE0B0B","J>	c #B01313","K>	c #B10606","L>	c #B95F5F","M>	c #826767","N>	c #A32020","O>	c #A49A9A","P>	c #A64646","Q>	c #A80C0C","R>	c #AA8E8E","S>	c #AB5757","T>	c #AC0101","U>	c #B74545",
	"V>	c #801414","W>	c #A26565","X>	c #A48B8B","Y>	c #A50D0D","Z>	c #A82C2C","`>	c #A91919"," ,	c #816565",".,	c #A01C1C","+,	c #A29595","@,	c #A34949","#,	c #827F7F","$,	c #7F1212","%,	c #9E0101","&,	c #A05252","*,	c #A13737","=,	c #802929","-,	c #9E0303",";,	c #804141",">,	c #816363",
	",,	c #816B6B","',	c #7F0303","),	c #814343","!,	c #837F7F","~,	c #813131","{,	c #9F5757","],	c #837070","^,	c #811414","/,	c #9D0303","(,	c #9E5555","_,	c #825656",":,	c #810202","<,	c #9C9494","[,	c #848080","},	c #823030","|,	c #9A0202","1,	c #9A5C5C","2,	c #835555","3,	c #810606",
	"4,	c #980606","5,	c #984F4F","6,	c #998F8F","7,	c #856F6F","8,	c #841C1C","9,	c #820202","0,	c #950B0B","a,	c #964C4C","b,	c #968C8C","c,	c #875D5D","d,	c #853131","e,	c #840606","f,	c #930202","g,	c #930D0D","h,	c #920D0D","i,	c #924949","j,	c #925656","k,	c #928787","l,	c #8A8383",
	"m,	c #895151","n,	c #881A1A","o,	c #860A0A","p,	c #5F0000","q,	c #8E0505","r,	c #8D0C0C","s,	c #8C0C0C","t,	c #8B0C0C","u,	c #8A0C0C","v,	c #890505",
	"                                                                                                                                                                                                                                                                                                                                  ",
	"                                                                                                                                                                                                                                                                                                                                  ",
	"                                                                                                                                                                                                                                                                                                                                  ",
	"                                                                                                                                                                                                                                                                                                                                  ",
	"                                                                                                                                                                                                                                                                                                                                  ",
	"                                                                                                                                                        . .                                                                                                                                                                       ",
	"                                                                                                                                                    + + + + + +                                                                                                                                                                   ",
	"                                                                                                                                                  @ @ @ @ @ @ # #                                                                                                                                                                 ",
	"                                                                                                                                                $ $ $ $ % % % % %                                                                                                                                                                 ",
	"                                                                                                                                              & & & * * * * * * * =                                                                                                                                                               ",
	"                                                                                                                                            = = - - - - ; ; ; ; ; ; > > ; ; ; - -                                                                                                                                                 ",
	"                                                                                                                                          ; ; > > > , , , , , , , , , , , , , > >                                                                                                                                                 ",
	"                                                                                                                                ; > > > , ' ' ' ' ) ) ) ) ! ! ! ! ! ! ! ) ) ) '                                                                                                                                                   ",
	"                                                                                                                            > > > , ' ' ) ) ! ! ~ ~ ~ { { { { { { { { { ~                                                                                                                                                         ",
	"                                                                                                                        , , , ' ) ! ! ~ ~ { { ] ] ^ ^ ^ ^ ^ / / / / ^                                                                                                                                                             ",
	"                                                                                                                      ' ' ) ! ! ~ { ] ] ^ ^ / / ( ( ( _ _ _ _ _ _ :   < < [ [ [ } } } | | 1 1 2                                                                                                                                   ",
	"                                                                                                                    ) ! ! ~ { ] ] ^ / ( ( _ _ 3 3 3 4 4 4 4 5 5 6 7 8 8 8 8 8 < < < [ [ } } | 1 1 2 9 9 0 0                                                                                                                       ",
	"                                                                                                                    ~ { { ] ^ / ( _ _ 3 3 4 5 5 5 a a a b b b b c d d d d e e e e 7 7 8 8 < [ [ } | 1 1 2 9 0 f f g                                                                                                               ",
	"                                                                                                                  { ] ^ / ( ( _ 3 4 5 5 a a b b h h i i i i i i j k l l l l l m m m d d e 7 7 8 < < [ } | 1 2 9 0 f g n                                                                                                           ",
	"                                                                                                                  ^ / ( _ _ 4 5 5 a b h h i i o o p p p p q q q q r s s s t t t u u l l m m d e e 7 8 < [ } | 1 2 9 0 f g n v                                                                                                     ",
	"                                                                                                                ( ( _ 3 3 a a b h i i o p p q q w w w x x x x x x y z z z z A A A s s t t u u l m d e 7 7 8 < [ | 1 2 9 0 g n v B                                                                                                 ",
	"                                                                                                                _ 3 4 5   b h i o p q q w x x C C C D D D E E E E E F G H H H H I I z z A A s t u u l m d e 7 8 < } | 1 2 0 f g v B J                                                                                             ",
	"                                                                                                              4 4 a b h i o p q q w x C C D D E E K K L L L L L L L M N N N O O O G G H H I z A A s t u l m d e 7 8 [ } | 1 9 0 g n v J P                                                                                         ",
	"                                                                                                              a a h i o p q w x C C D E K K L L Q Q R R R R S S S S T U U U U V V V N O O G G H I z A s t u l m d e 8 < [ } 1 2 0 f n v J P W                                                                                     ",
	"                                                                                                              h i o p q w x C D E K L L Q R R S S X X X Y Y Y Y Y Y Z ` `  . . .....U U V V N O G H I z A s t u l m d 7 8 < } | 2 9 f g v B P W                                                                                   ",
	"                                                                                                              o p q w x C D E K L Q R S S X X X +.+.+.@.@.@.@.#.#.#.#.$.%.%.%.&.&.` `  . ...U V V N O G H I z s t u l d e 7 < [ | 1 9 0 g n B P W *.                                                                              ",
	"                                                                                                              q w x C D K K   R S S X Y +.+.+.  =.=.=.=.-.-.-.-.-.-.-.;.>.,.,.,.'.'.%.%.&.`  . ...U V N O G H z A s t l m d 7 8 [ } 1 2 0 g n B P W ).                                                                            ",
	"                                                                                                            w x C D E L Q Q   X Y +.@.@.#.=.=.  !.!.!.~.~.~.~.~.~.~.~.{.].].^.^.^.>.>.,.'.'.%.&.`  ...U V N O G I z A t u l d e 8 < } 1 2 0 g n B P W ).                                                                          ",
	"                                                                                                            /.D E K Q R S X   +.@.#.=.-.-.!.~.  (.(._._._.:.:.:.:.:.:.<.[.[.[.[.}.}.].^.^.>.,.'.%.&.`  ...U V N G H I A s t l m e 8 < } | 2 0 f n B P *.).                                                                        ",
	"                                                                                                          I |.K L Q S X Y +.#.#.=.-.!.~.(.(._.:.:.1.1.2.2.2.2.2.2.2.2.2.3.4.5.5.6.6.[.[.}.].^.^.>.,.'.%.`  ...U V O G I z A t l m e 7 < } | 2 0 g n B P *.7.7.                                                                    ",
	"                                                                                                      I H 8.9.Q R S Y +.@.#.=.!.~.~.(._.:.1.1.2.0.0.a.a.a.b.b.b.b.b.b.b.c.d.d.e.e.4.4.5.6.6.[.}.].^.>.,.'.&.`  ...V N G H z A t u m d 7 < } | 2 0 g v B P *.7.f.                                                                  ",
	"                                                                                                    I H G g.Q S X +.@.#.=.!.~.(._.:.1.2.2.0.a.a.b.h.h.h.i.i.i.i.i.i.i.i.j.k.k.k.l.l.d.e.e.4.5.6.[.}.].^.>.,.%.&.` ..U N O H I A s u m d 7 < } | 2 0 g v J W ).7.f.                                                                ",
	"                                                                                                  H H O m.R S Y +.#.=.-.!.(._.:.1.2.0.a.b.b.h.i.i.n.n.o.o.o.p.p.p.p.p.o.o.q.r.s.s.t.k.k.l.d.e.4.5.6.[.}.].^.,.'.%.`  .U V O G I A s u m d 7 < } 1 9 0 g v J W ).f.                                                                ",
	"                                                                                                H H O u.R X Y @.#.-.!.~._.:.1.2.0.a.b.h.i.n.o.o.p.p.v.v.w.w.w.w.w.w.w.w.w.x.y.y.z.r.r.s.t.k.k.l.d.4.5.6.[.}.^.>.,.%.&. ...V O G I A s u m e 7 < } 1 9 f n B P *.7.f.                                                              ",
	"                                                                                                G O A.B.X +.@.=.-.~.(._.1.2.0.a.b.h.n.n.o.p.v.w.w.C.C.D.D.D.D.E.E.E.E.D.D.F.G.H.I.y.y.z.z.r.s.t.k.l.e.4.5.6.}.].^.,.'.&.` ..V N G I A s u m e 8 [ } 1 9 f n B P *.7.J.                                                            ",
	"                                                                                              G O V K.X +.@.=.!.~._.:.1.0.a.b.h.n.o.p.v.v.w.C.D.E.E.L.L.L.M.M.M.M.M.M.M.M.L.M.              r.s.t.k.l.d.e.4.6.[.}.^.>.'.&.` ..V N G I A s u m e 8 [ | 2 0 g v J W ).f.J.                                                          ",
	"                                                                                            G O V N.X +.#.=.!.~._.1.2.0.b.h.i.o.p.v.v.  E.E.L.L.M.M.O.O.P.P.P.P.Q.Q.P.P.P.P.O.P.                      l.l.e.4.5.6.}.^.>.'.%.` ..V N G I A t l d e 8 [ | 2 0 g v P *.7.J.R.                                                        ",
	"                                                                                          G O V U S.+.#.=.!.(._.1.2.a.b.i.n.o.v.w.C.E.L.L.M.O.P.P.Q.Q.T.T.U.U.U.U.U.U.U.T.T.T.T.                            e.4.5.6.}.].>.'.%.` ..V O G I A t l d 7 < } 1 9 f n B P *.f.R.V.                                                      ",
	"                                                                                        G O N U  .W.#.=.!.(.:.1.0.a.h.i.o.p.w.C.D.E.L.M.O.P.Q.T.U.U.X.X.Y.Y.Y.Y.Y.Y.Y.Y.Y.X.X.X.X.                                5.6.}.].>.'.%.` ..V O H z s u m e 8 [ | 2 0 g v J W ).f.R.                                                      ",
	"                                                                                        O N U  .Z.#.=.!.(.:.1.0.b.h.n.o.v.w.D.E.L.M.O.Q.T.U.U.X.Y.`.`. + + +.+.+.+.+.+ + + +`.`.`.                                    [.}.].>.'.&. ...V O H z s u m e 8 [ | 9 f n B P *.7.J.V.                                                    ",
	"                                                                                      O N U ..` ++=.!.(.:.1.0.b.h.n.p.v.C.D.L.M.O.P.T.U.X.Y.`. + +.+@+@+#+#+#+#+#+#+#+#+#+@+@+.+.+      `.Y.                              }.].>.'.&. .U N G I A t l d 7 < } 1 9 g v J W ).f.R.$+                                                  ",
	"                                                                                      O V ..` %.%+!.(._.1.0.b.i.n.p.w.C.E.L.O.P.Q.U.X.Y.`. +.+@+#+#+&+&+*+*+=+=+=+=+=+*+*+*+&+&+#+#+@+.+`.Y.Y.U.T.Q.P.M.L.                  ].^.,.'.&. .U N G I A u m e 8 [ | 2 0 n B P *.7.J.V.                                                  ",
	"                                                                                    O N U  .&.'.-.~._.1.0.b.i.n.p.w.C.E.M.O.Q.T.U.Y.`. +.+@+#+&+*+=+=+-+-+;+;+;+;+;+;+;+-+-+=+=+*+&+&+#+@+.+`.Y.X.T.Q.P.M.L.D.C.w.p.            ^.,.%.` ..>+,+'+z s u m 7 < } 1 9 f v J W ).f.V.$+                                                ",
	"                                                                                  O N U  .&.'.)+~._.1.0.a.h.n.p.w.C.E.M.O.Q.U.X.Y. +.+@+  &+=+=+-+;+!+!+~+~+~+{+{+{+~+~+~+~+!+;+;+-+=+*+&+#+.+ +`.X.U.T.P.M.L.D.w.v.o.n.h.    6.].>.'.&. .]+^+/+I A t l d 8 [ | 2 0 n B P *.7.R.$+                                                ",
	"                                                                                  O V ..` %.,.(+(.:.2.a.h.n.p.w.C.E.M.P.Q.U.X.`. +@+#+      ;+!+~+~+{+_+_+:+:+:+:+:+:+:+_+_+{+{+~+!+;+-+=+*+&+@+.+`.Y.U.T.P.M.L.D.w.p.o.i.<+e.5.[.].>.'.&.[+}+|+1+z s u m e < } 1 9 g v J W ).J.V.2+                                              ",
	"                                                                                O N U  .&.'.>.3+:.2.a.h.i.o.v.C.E.M.P.Q.U.Y.`..+@+&+*+      ~+{+_+:+4+4+5+5+5+5+6+6+5+5+5+4+4+:+_+{+~+!+;+-+=+&+#+.+ +Y.X.T.P.M.L.D.w.p.7+8+d.4.6.}.^.,.9+0+a+b+c+d+A t l d 8 [ | 2 f n B P ).f.R.$+                                              ",
	"                                                                                O V ..` '.>.].[.1.0.b.i.o.v.C.E.M.P.Q.U.Y. +.+#+&+=+-+      :+:+4+5+6+e+e+e+f+f+f+f+f+f+e+e+6+5+4+4+:+{+~+!+;+=+*+#+@+ +Y.X.T.P.M.E.D.g+z.s.k.d.4.6.].>.h+i+j+k+l+m+z s u m 7 < } 1 0 g v J *.7.J.$+2+                                            ",
	"                                                                              O N U  .%.,.^.}.6.2.a.h.n.p.w.D.L.O.Q.U.Y. +.+#+*+=+;+!+      5+5+6+e+f+n+n+o+o+o+o+o+o+o+o+n+n+f+e+6+5+4+_+{+~+;+-+*+&+@+ +Y.X.T.P.p+q+H.y.r.t.l.e.5.[.r+s+t+u+v+w+x+d+A t l e 8 [ | 9 f n J W ).f.V.2+                                            ",
	"                                                                              O V ..` '.>.].[.5.y+h.n.p.w.D.L.O.Q.U.Y.`..+#+*+=+;+~+{+    6+e+f+n+o+z+z+A+A+B+B+B+B+B+A+A+z+z+o+n+f+e+6+5+:+_+~+!+-+*+&+@+ +Y.U.C+D+E+F+I.z.s.k.d.G+6.H+I+J+&.[+K+L+M+z s u d 7 < | 2 0 g B P *.f.R.$+N+                                          ",
	"                                                                              N U  .&.,.^.}.6.4.c.i.o.v.C.E.M.P.T.X.`..+#+*+=+;+~+_+:+5+e+f+n+o+z+A+B+O+O+P+P+P+P+P+P+P+O+O+B+A+z+o+n+f+e+5+4+_+~+!+-+*+#+@+ +Q+R+S+T+E+F+I.z.U+V+W+X+Y+Z+`+%. @.@+@@@I A u m e 8 } 1 9 g v J *.7.J.$+N+                                          ",
	"                                                                            O V ..` %.>.].[.5.e.k.#@p.w.D.L.O.Q.U.`..+#+&+=+;+~+_+:+5+e+f+n+z+A+B+O+P+$@%@%@%@&@&@&@%@%@%@$@P+P+O+A+z+o+n+e+5+4+_+~+!+-+*+*@=@-@;@>@,@'@)@H.!@~@{@]@^@/@(@_@:@<@[@}@|@H z t l d 8 [ | 9 f n J W ).J.V.2+1@                                        ",
	"                                                                            N U  .&.'.^.}.6.4.l.t.2@v.C.E.O.Q.U.Y. +@+&+=+;+~+_+:+5+e+f+o+z+B+O+P+$@%@&@3@3@4@4@4@4@4@4@3@3@&@%@$@P+B+A+o+n+e+6+4+_+~+;+5@6@7@8@9@;@S+T+E+0@a@b@c@d@e@f@g@h@i@j@k@U N G z s u m 7 < } 2 0 g B P ).f.R.l@m@n@o@p@                                  ",
	"                                                                            N U ` %.,.].[.5.e.k.s.q@r@D.M.P.T.X.`..+#+*+-+!+{+:+5+e+n+o+A+B+P+$@&@3@4@s@s@t@t@u@u@u@t@t@t@s@4@3@&@%@P+O+A+z+n+e+6+4+_+v@w@x@y@z@A@9@R+,@B@C@D@E@F@k.G@H@I@J@K@L@` ..V O I A t m e 8 } 1 9 g v P *.M@N@+ . n@O@p@                                  ",
	"                                                                          O V ..` '.>.].6.4.d.k.r.y.P@Q@O.Q.U.Y. +@+*+-+!+{+:+5+e+f+o+A+O+P+%@&@4@s@t@u@R@R@S@S@S@S@S@R@R@u@t@s@4@3@%@$@O+B+z+n+e+T@U@V@W@X@Y@7@8@-@;@Z@`@ #.#+#@###$#%#&#*#^.,.&. .U O H z t l d 8 [ | 9 f v =#-#% # ;#. >#O@o@                                  ",
	"                                                                          O U  .&.,.^.}.5.e.l.t.z.I.F+,#'#T.X.`..+&+=+;+~+_+4+6+f+o+A+B+P+%@&@4@t@u@R@S@)#!#!#!#~#~#!#!#)#S@R@u@t@s@3@&@$@O+B+z+{#]#^#/#V@W@x@y@z@(#_#R+:#<#[#}#|#1#k.2#3#4#].,.%.` U N G z s u d 7 [ | 2 5#6#> = & # ;#7#>#8#                                    ",
	"                                                                        O N U ` %.,.].[.5.d.k.s.y.H.)@9#0#U.Y. +#+*+-+!+{+:+5+e+o+A+O+P+&@4@t@u@R@S@)#!#~#a#b#b#b#b#b#a#a#~#!#S@R@u@s@3@&@$@O+c#d#e#f#g#h#i#w@x@j#k#l#m#n#`@o#.#p#q###d.4.6.].>.'.` ..N G I A u m 7 < r#s#~ ) > - & $ @ t#u#                                      ",
	"                                                                        O N ..` '.>.].6.4.d.t.r.y.H.v#w#Q.X.`..+&+=+;+~+_+5+e+n+z+B+P+%@3@s@t@R@)#!#~#b#x#x#y#y#y#y#y#y#x#b#a#~#)#S@u@s@3@z#A#B#C#D#E#^#/#V@F#G#H#I#J#K#>@L#M#N#O#P#Q#l.e.6.}.^.'.&.    O I A t m e R#S#^ ~ ) , - * $ T#U#1@V#                                    ",
	"                                                                        O V ..&.'.^.}.6.e.l.t.z.W#X#M.P.T.X. +@+&+-+!+{+4+6+f+o+A+O+$@&@4@t@R@)#!#a#b#y#Y#Z#Z#`#`#`#`#Z#Y#y#x#b#~#)#S@u@ $.$+$@$#$$$D#f#g#%$&$*$=$-$;$>$,$'$)$!$~${$s.k.e.5.[.^.]$      O H ^$/$($_$4 _ ^ { ) , ; * :$<$$+N+[$                                    ",
	"                                                                        O V  .&.,.^.}.5.e.k.s.z.}$E.M.Q.U.Y..+#+*+;+~+_+4+e+n+z+B+P+&@4@t@R@)#~#a#x#y#Z#`#|$1$1$1$1$1$|$`#Z#Y#x#b#~#)#2$3$4$5$6$B#7$8$E#9$0$a$b$c$d$I#e$f$g$h$i$F+y.r.k.d.4.[.j$=.@.Y R k$l$x p i b 4 _ / { ! , m$n$7.J.$+N+V#                                    ",
	"                                                                      G N U  .%.,.].[.5.d.k.s.o$C.L.O.Q.X.`..+&+=+;+{+:+5+f+o+A+O+%@3@s@u@S@!#a#x#Y#Z#|$1$p$q$r$r$r$q$q$p$|$`#Y#y#s$t$u$v$w$4$+$x$y$z$A$B$C$D$F#E$F$G$H$I$J$K$E+F+I.r.t.l.4.L$~.-.#.Y S L E C q o b 5 _ / ] ! M$N$W ).J.V.N+V#O$                                  ",
	"                                                                      G N U ` %.>.].[.4.d.t.P$v.D.L.P.T.X. +@+&+-+!+{+4+6+f+z+B+P+&@4@t@R@)#~#x#Y#Z#|$p$q$r$Q$R$R$R$R$Q$r$p$1$`#S$T$U$V$W$X$Y$5$Z$`$ %.%+%@%#%i#$%%%&%*%=%-%,@'@)@I.z.t.$#;%:.(.-.#.Y S Q E C q o h 5 3 / ] >%,%B W ).J.V.2+V#O$                                  ",
	"                                                                      G N ..` %.>.].6.4.l.'%)%w.D.M.P.T.Y. +@+*+-+~+_+4+e+n+z+O+$@&@s@u@S@!#b#y#Z#|$p$r$Q$!%~%~%{%{%~%!%R$r$p$]%^%/%(%_%u$v$Y$:%<%[%}%|%1%2%3%i#4%5%6%8@-@R+S+'@)@H.z.7%8%0.:.(.!.#.+.S Q K C w o h 5 3 ( 9%0 n B W ).f.V.2+V#[$                                  ",
	"                                                                      G N ..` '.>.}.6.4.l.0%p.w.E.M.P.U.Y..+#+*+;+~+:+5+e+o+A+O+%@3@s@R@)#~#x#Y#`#1$q$Q$!%{%a%b%b%b%a%{%~%c%d%e%f%g%h%U$V$W$w$4$i%j%k%l%m%n%o%p%q%r%s%8@-@;@S+T+)@H.t%n.h.0.1.(.!.=.+.X Q K C w p h a 3 ( u%0 n B P ).f.V.2+V#O$                                  ",
	"                                                                      G V ..&.'.>.}.6.e.v%n.p.w.E.M.Q.U.`..+#+=+;+{+:+5+f+o+B+P+%@4@t@S@!#a#x#Z#|$p$Q$!%{%b%w%x%y%x%w%b%z%A%B%C%D%E%F%(%_%W$X$Y$5$G%H%I%J%K%L%M%N%O%y@z@-@;@S+T+E+P%v.n.h.0.1._.!.=.+.X Q K D w p h a 3 ( ^ ~ ) > - & $ @ 7#Q%8#o@R%S%T%U%V%                      ",
	"                                                                      G V ..&.'.^.}.6.W%b.n.p.C.E.M.Q.U.`..+&+=+;+{+:+6+f+z+B+P+&@4@u@S@!#b#y#`#1$q$R$~%a%w%y%X%Y%Y%y%Z%`% &.&+&e%E%/%h%@&#&$&Y$:%6$%&I%&&*&=&-&;&X@y@z@A@;@>@T+>&C.v.o.h.a.1._.!.=.@.X R K D w p h a 4 ( ^ ~ ) > - * $ @ 7#Q%8#o@R%S%,&U%V%'&)&                  ",
	"                                                                      O V ..&.'.^.}.!&~&b.n.p.C.E.O.Q.U.`..+&+=+!+{+4+6+f+z+B+$@&@s@u@S@~#b#Y#`#1$r$R${%b%x%X%{&]&^&/&(&_& &:&B%e%f%/%<&[&}&|&1&:%+$2&3&4&5&g#h#W@X@Y@z@A@;@6&7&L.D.v.o.h.a.1._.~.=.@.X R K D w p i a 4 ( ^ ~ ) > - * $ @ 7#Q%8#o@p@S%,&U%V%'&)&                  ",
	"                                                                    H O V ..&.'.^.}.8&0.b.n.p.C.E.O.Q.U.`..+&+=+!+{+4+6+f+z+B+$@&@s@u@)#~#b#Y#`#p$r$!%{%b%y%Y%]&9&0&a&b&_&c&:&B%C%f%d&e&f&g&h&i&j&+$B#k&l&m&g#h#i#X@Y@z@A@n&o&O.L.D.v.o.h.a.1._.~.=.@.X R K D w p i a 4 ( ^ ~ ) , - * $ @ 7#Q%8#o@p@S%,&U%V%'&)&                  ",
	"                                                                    H O V ..&.'.^.p&1.0.b.n.p.C.E.O.Q.U.`..+&+=+!+{+4+6+f+z+B+$@&@s@u@S@~#b#Y#`#p$r$R${%b%x%Y%q&r&s&a&(&_&c&:&B%t&f%u&v&w&x&h&y&z&+$B#C#A&E#g#h#W@X@Y@z@B&X.T.O.L.D.v.o.h.a.1._.~.=.@.X R K D w p i a 4 ( ^ ~ ) , - * $ @ 7#Q%8#o@p@S%,&U%V%                      ",
	"                    )&C&D&T%E&R%                                    H G V ..&.'.F&G&:.0.b.n.p.C.E.O.Q.U.`..+&+=+!+{+:+6+f+z+B+$@&@4@u@S@~#b#y#`#1$q$R$~%a%H&I&J&a&J&b&K&L& &:&M&N&O&P&Q&R&S&T&U&V&6$B#C#D#E#g#h#W@X@Y@W&`.X.T.O.L.C.v.o.h.a.1._.!.=.@.X R K D w p h a 4 ( ^ ~ ) > - * $ T#X&Y&Z&`&p@S%                            ",
	"                    )&C&D&T%E&R% *O@>#. ;#@                         H G V ..&..*+*(.:.0.b.n.p.w.E.M.Q.U.`..+#+=+;+{+:+6+f+o+B+P+&@4@t@S@!#a#y#Z#|$q$Q$!%@*#*K&(&(&(&K&_&c&$*%*&***=*-*;*>*,*'*)*!*6$B#$$D#f#g#h#W@~*{*@+`.X.T.O.L.C.v.n.h.a.1._.!.=.+.X R K D w p h a 3 ( ^ ~ ) ]*^*).f.R.2+1@O$/*                                ",
	"                    '&C&D&T%E&(* *O@>#. ;## % = ;                   H G V ..` _*-.(.:.0.b.i.p.w.E.M.P.U.Y..+#+=+;+~+:+5+f+o+A+P+%@3@t@R@)#a#x#Y#|$p$r$:*<* &L&_&_&_&L&c&[*}*|*1*2*3*4*5*6*7*8*9*0*@$#$$$e#f#g#V@a*b*&+@+`.X.Q.O.E.C.v.n.h.0.1.(.!.=.+.X Q K C w p h a 3 ( ] ~ ) c*d*).f.V.2+1@O$e*                                ",
	"                        D&f*E&(* *O@>#. + # % = ; ' ! { ^           I G N ..g*h*-.~.:.2.b.i.o.w.D.M.P.U.Y. +#+*+-+~+_+5+e+n+A+O+$@3@s@u@)#~#b#y#Z#i*j*+&.&:&[* & & & &[*k*l*m*n*o*p*q*r*s*t*u*v*+$@$C#d#e#^#/#w*;+=+#+.+`.U.Q.M.E.C.p.n.b.0.1.(.!.#.+.S Q K C w o h a 3 ( ] ~ ' > x*y*z*V.2+V#O$e*                                ",
	"                          f*E&(*p@O@n@. + # % * ; , ! { / _ 4 a i   I G N U A*@.-.~._.2.a.i.o.w.D.L.P.T.Y. +@+*+-+!+_+4+6+n+z+B+$@&@4@t@S@!#a#x#B*C*D%e%+&B%.&:&:&:&D*E*F*G*H*f%I*J*K*L*M*N*Y$:%6$B#C#D#E#^#O*~+;+*+#+.+Y.U.P.M.E.w.p.i.b.0.:.(.-.#.+.S Q E C w o h 5 3 / ] ~ ' > = & # P*Q*V#O$e*                                ",
	"                              (*p@O@n@. + @ % * ; , ) { ^ _ 4 b i p R*S*T*U*Y @.=.~._.1.a.h.o.v.C.L.O.T.X.`.@+&+=+!+{+:+6+f+o+A+P+%@3@s@u@)#~#V*W*/%E%D%e%C%+&+&X*Y*Z*`* =.=+=g%@=#=$=g&v$w$4$5$@$#$$$D#%=&=_+!+-+*+@+ +Y.T.P.M.D.w.o.i.b.2.:.~.-.#.Y S L E C q o b 5 3 / ] ! ' ; = & # ;#. *===e*                                ",
	"                                  O@n@Q%+ @ $ * - , ) { ^ ( 4 a i p w D K R X +.=.!._.1.0.h.n.v.C.E.O.Q.U.`..+#+*+;+~+_+5+e+n+A+O+$@&@4@t@-=;=_%(%F%/%E%f%D%e%>=,='=)=!=~={=]=^=/=(=_=:=X$Y$:%+$B#C#d#<=[=:+{+!+=+&+@+`.X.Q.O.L.D.v.o.i.a.2._.~.-.@.Y R L E x }=|=1=2=3=4={ ! ' ; = % # + . >#O@ *(*                              ",
	"                                      Q%7#@ $ * - > ) ~ ^ ( 3 a h p w C K Q X +.#.!.(.:.0.b.n.p.w.E.M.P.U.Y. +@+*+-+!+_+4+6+f+o+B+P+%@3@5=6=W$u$_%(%h%F%g%E%E%7=8=9=0=a=b=c=d=e=f=g=h=i=Y$:%+$@$#$$$j=k=5+_+~+;+*+#+.+`.U.Q.O.E.C.v.n.h.a.1._.~.=.@.X R L D x l=l d 8 [ 1 9 m=n=o=* % # + . n@O@p@(*E&                            ",
	"                                  o@8#Q%7#;#$ & - > ' ~ ] ( 3 5 h o w C E Q S Y #.-.(.:.2.b.i.o.w.D.L.P.T.X.`.@+&+=+;+{+:+5+e+n+z+B+P+p=q=Y$X$W$u$_%U$(%h%F%r=s=t=u=/%v=w=x=y=z=A=B=C=D=4$5$6$B#C#E=f+6+4+{+!+-+*+@+ +Y.T.P.M.E.w.p.n.b.0.1.(.!.=.+.X Q K D w F=l e 8 } 1 9 g v P *.G=H=I=Q%n@o@p@(*E&                            ",
	"                          U%T%E&R% *8#>#. ;## & = ; ' ! ] / _ 5 b o q x E L R Y @.-.~._.2.a.h.n.v.C.E.O.Q.U.Y..+#+*+-+~+_+4+6+f+o+J=K=6$5$:%Y$X$v$u$V$L=M=N=O=P=Q=R=h%S=T=U=V=W=X=Y=Z=4$5$+$@$#$`=n+e+4+_+~+;+=+&+.+`.X.T.O.L.D.w.o.i.b.2.:.(.-.#.+.S Q E C w  -m e < } 2 0 g B P ).f.R.2+1@.-+-p@(*                              ",
	"                        C&D&T%E&(* *O@>#. + # % = ; , ! { / _ 4 b i p x D K R X +.=.!.(.1.0.b.n.p.w.E.M.P.T.X. +@+&+=+;+~+_+5+e+{#@-C#B#6$5$:%Y$w$v$#-$-%-&-*-=---;->-,-'-)-!-~-{-]-^-5$+$@$/-(-n+e+5+:+{+!+-+*+#+ +Y.U.Q.O.E.C.v.n.h.a.1._.~.-.@.Y S L E C q  -d 7 < | 2 0 n B W ).f.V.2+V#O$e*                                  ",
	"                      '&_-D&f*E&(*p@O@n@. + @ % * - , ) { ^ ( 4 a h p w C K Q S +.#.-.(.:.2.b.i.o.v.D.L.O.Q.U.`.    =+-+!+{+:+:-<-D#$$#$B#6$+$:%4$[-}-|-1-2-3-4-5-6-7-8-9-v$X$w$Y$:%5$6$@$0-a-o+f+6+4+_+~+;+=+&+.+`.X.T.P.M.D.w.p.n.b.0.1.(.!.=.@.X R L D x q b-d 8 [ | 9 f n J W 7.J.V.N+V#O$c-                                  ",
	"                          V%f*,&S%p@o@n@Q%7#@ $ & - > ) ~ ] ( 3 5 h o q C E L S Y @.-.~._.1.a.h.n.p.C.E.d-e-        *+=+;+f-g-g#f#E#D#$$h-B#6$+$i-j-k-l-m-n-o-p-q-r-s-t-w$w$Y$4$:%+$6$@$u-z+o+f+6+4+_+~+;+=+&+@+ +Y.U.Q.O.L.C.v.o.h.a.2.:.(.-.#.+.S Q K C w p v-e 8 } 1 9 g v J *.7.J.$+N+[$/*c-                                  ",
	"                              ,&(*R%o@8#>#7#;#$ & = > ' ! ] / _ 5 b i q x D L R X +.=.!.(.:.0.b.i.o.v.w-x-T+          *+y-z-i#h#g#f#E#A-B-C-D-E-F-G-H-I-J-^-K-L-M-Y$Y$4$4$:%5$+$6$@$B#N-z+o+f+6+5+:+{+!+-+*+#+.+`.X.T.P.M.D.w.p.n.h.0.1._.~.=.@.Y S L E C q o O-7 < } 2 0 g B P *.f.R.$+1@[$e*c-                                  ",
	"                                        >#7#;## % = ; , ! { ^ _ 4 a i p w C K Q S Y #.-.~._.2.a.h.P-Q-H.)@'@T+        R-S-X@W@i#h#g#f#T-U-V-W-X-Y-Z-`- ;.;5$+;@;.$:%5$5$5$+$6$@$B##;$;z+n+f+6+4+:+{+!+-+=+&+@+ +Y.U.Q.O.E.C.v.o.i.b.2.:.(.!.#.+.X R K D x q i d 7 [ | 2 f n B W ).f.V.2+1@O$e*%;                                  ",
	"                                          . + @ % * - , ) ~ ] ( 3 5 h o q C E L R Y @.=.!.(.1.0.&;*;r.y.H.E+'@      A@z@7@Y@X@W@i#h#g#^#=;-;;;>;,;';2&);!;~;6${;6$6$6$6$@$@$B##$];^;o+n+e+6+4+:+{+!+;+=+&+@+ +Y.U.Q.O.L.D.w.p.n.h.0.1._.~.-.@.Y S Q K C w p /;e 8 [ 1 9 f v J W 7.J.V.N+V#O$c-%;                                  ",
	"                                        8#Q%7#;#$ & = > ' ! ] / _ 5 b i p x D K Q X +.#.-.~._.(;_;k.s.z.I.F+E+  S+R+9@A@z@y@Y@X@W@i#h#/#:;<;[;};|;1;$$2;3;4;#$B#B#B##$#$#$C#C#5;6;n+f+6+5+4+_+{+!+;+=+&+@+.+`.X.T.P.M.E.C.v.o.i.a.2.:.(.!.=.+.X R L E x q o 7;7 < } 2 0 g v P *.7.R.$+N+[$/*c-                                    ",
	"                                       *8#>#. ;## % = ; , ! { ^ ( 4 a h o w C E L R Y @.=.!.8;9;e.l.t.r.y.H.)@'@,@>@R+9@A@z@y@Y@X@w@i#V@0;a;b;c;d;e;f;d#g;h;$$$$$$$$$$$$d#d#i;f+f+e+5+4+:+_+~+!+-+=+&+@+.+`.X.T.P.M.E.C.w.o.i.b.0.1._.~.-.#.Y S Q K D w p i j;8 [ | 2 f n B W ).f.R.2+1@[$e*%;                                    ",
	"                                    R% *O@n@. + @ % *         ^ ( 3 a h i q x D K Q X +.#.-.k;[.5.e.l.t.r.y.H.)@'@,@>@;@9@A@z@7@Y@x@w@W@V@l;m;n;o;p;q;E#e#e#D#D#D#D#D#e#e#r;e+6+5+4+:+_+{+~+;+-+*+&+@+.+`.X.T.Q.O.L.D.w.p.n.h.a.2.:.(.!.=.+.X R L E C q o h s;< } 1 9 g v J W 7.J.V.N+V#O$c-%;                                    ",
	"                                    (*p@o@n@Q%7#@                         t;u;C E L R Y @.=.!.}.6.4.d.k.s.z.I.F+E+'@,@>@;@9@v;w;x;y;z;X@w@i#A;B;C;D;E;^#^#f#f#f#f#f#f#F;G;5+5+4+:+_+{+~+!+;+=+*+&+@+ +`.X.U.Q.O.L.D.w.v.o.i.b.0.1._.~.=.@.Y S Q K D x p i b H;[ | 2 0 g B P *.f.R.$+N+[$/*c-I;                                    ",
	"                                    S%p@                                  u s J;D K Q S Y #.=.].[.5.e.l.t.s.z.I.F+E+'@,@>@R+K;L;M;N;O;P;x@X@Q;R;S;V@h#/#/#/#g#g#g#g#T;U;:+:+_+{+{+~+!+;+-+*+&+#+@+ +`.X.T.Q.O.L.E.C.v.o.i.b.0.1._.~.-.#.+.X R L E C q o h V;< } 1 9 f n J W ).f.V.2+1@O$e*%;                                      ",
	"                                                                          l t A W;X;L R X +.#.>.].[.5.e.l.t.r.y.I.F+E+'@,@Y;Z;`; >.>+>@>y@Y@x@#>$>W@i#i#V@V@V@V@V@%>{+{+{+~+~+!+;+;+-+=+*+#+@+.+ +Y.X.T.Q.O.L.E.C.v.o.i.h.a.2.:.(.!.=.@.Y S Q K C w p i b &>< | 2 0 g v P *.7.J.$+N+V#O$c-%;                                      ",
	"                                                                          m l t z *>=>Q S Y @.,.^.}.6.4.e.l.t.r.y.I.F+->'@;>C+>>;@,>'>)>z@7@y@Y@x@X@X@w@w@W@W@W@!>!+!+!+;+;+-+-+=+*+&+#+@+.+ +`.X.U.T.P.O.L.E.C.v.o.n.h.a.2.:.(.!.=.#.+.S Q K D x q o h a ~>} 1 9 f n B W ).f.R.2+1@[$/*%;I;                                      ",
	"                                                                            l u s z {>k$Q S ]>%.,.^.}.6.4.d.l.t.r.^>/>(>_>:>7&<>>@[>}>|>A@8@z@7@7@y@Y@Y@x@x@1>2>-+-+=+=+=+*+*+&+&+#+@+.+ +`.Y.X.T.Q.P.M.L.D.C.v.o.n.h.a.2.1._.~.-.#.+.X R L E C w p i b 3>[ | 2 0 g v P *.7.J.V.N+V#O$e*%;                                        ",
	"                                                                            d l t A I 4>5>R 6>&.'.>.].}.6.4.d.l.7>8>9>0>a>b>c>d>e>f>g>h>9@-@A@A@8@z@z@7@7@i>j>&+&+&+&+&+#+#+#+@+.+.+ +`.Y.X.U.T.P.O.M.E.D.w.v.o.n.h.a.0.1._.~.-.#.@.Y S Q K D x q o h 5 k>} 1 9 f n B W ).f.R.$+1@[$/*c-I;                                        ",
	"                                                                            d m u s z H l>m>n> .&.'.>.].}.6.4.o>p>q>r>s>t>P%u>v>w>x>y>S+>@R+;@9@-@-@A@8@z>A>.+@+@+@+.+.+.+.+ + +`.Y.X.X.U.T.Q.O.M.L.E.C.w.p.o.i.h.a.0.1._.~.!.=.@.Y S Q K D x q o h a 4 B>| 2 0 g v P *.7.J.V.2+V#O$e*%;                                          ",
	"                                                                              e m u s z H O V ..` &.'.>.].}.6.G+C>D>E>s.F>G>H>I>J>K>'@T+,@S+>@R+R+;@9@L>Y.`.`.`.`.`.`.`.`.Y.Y.X.X.U.T.Q.P.O.M.L.E.D.C.v.p.n.i.h.a.2.1._.~.!.=.@.Y S R L E C w p i b 5 M>} 1 9 f v J W ).f.R.$+1@[$/*c-I;                                          ",
	"                                                                              e d l t A I H O V ..` %.'.>.].}.6.N>O>P>k.Q>R>S>T>H.F+)@E+'@T+,@,@S+>@U>U.U.U.X.X.X.X.X.U.U.U.T.T.Q.Q.P.O.M.L.E.D.C.w.v.o.n.i.b.a.2.1._.~.!.=.@.Y X R L E C w p i b 5 3 V>1 9 f n B P *.7.J.V.N+V#O$e*%;I;                                          ",
	"                                                                                e d l t A I G N V ..` %.'.>.].}.9;W>X>Y>l.Z>`>r.z.I.H.F+)@)@E+'@T+      Q.Q.Q.Q.Q.Q.Q.Q.Q.P.P.O.O.M.M.L.E.D.C.w.v.p.n.i.h.b.0.2.:._.~.-.=.@.Y X R L E D x q o h a 4  ,| 2 0 g v J W ).f.R.2+1@[$/*c-I;                                            ",
	"                                                                                7 e m u t A I G N V ..` &.'.>.^.}..,+,@,e.l.k.t.s.r.z.y.I.H.F+)@          O.O.O.O.O.O.O.M.M.M.L.L.E.D.C.C.w.v.p.o.n.h.b.a.2.1.:.(.~.-.=.@.Y X R L E D x q o h a 5 #,$,1 9 f n B P *.f.R.$+N+V#O$e*%;I;                                            ",
	"                                                                                  7 e m u s A I G N V ..` &.'.,.^.%,&,*,5.e.d.l.k.t.s.r.z.y.I.          E.E.E.L.L.E.E.E.E.E.D.D.C.C.w.v.p.o.o.n.h.b.a.0.2.:._.(.!.-.#.@.Y X R L K D x q o i b 5 3 =,1 9 f n B P *.7.J.V.2+1@[$/*c-I;                                              ",
	"                                                                                  8 7 e m u s A I G N V .. .&.%.,.>.-,*#[.6.4.e.d.l.k.t.s.r.            w.C.C.C.C.C.D.C.w.w.w.v.v.v.p.o.n.i.h.b.a.0.2.1.:.(.~.!.=.#.+.Y S R L E D x q p i b 5 3 ;,| 2 0 g v J W ).f.R.$+N+V#O$e*%;                                                ",
	"                                                                                    < 7 d m u s A I G O V U  .` %.'.>.^.].}.6.5.4.e.d.l.k.            p.p.p.p.p.p.p.p.p.p.o.o.o.n.n.i.h.h.b.a.0.2.1.:._.(.!.-.=.@.+.X S Q L E D x q p i b 5 4 >,| 2 0 g v J W ).f.R.$+N+V#O$e*%;I;                                                ",
	"                                                                                      < 7 d m u s A I H O V U ..` &.'.,.>.^.].}.6.6.5.5.              i.n.n.n.n.n.n.n.n.n.i.i.i.h.b.b.a.0.0.2.1.:._.(.~.-.=.#.@.Y X R Q L E C x q p i b 5 4 ,,',2 0 f n B P *.7.J.V.2+1@[$/*c-I;                                                  ",
	"                                                                                      < < 7 d m u t A I H O N V .. .` %.'.,.>.^.].}.[.6.6.          a.b.b.b.b.h.h.h.h.b.b.b.b.a.a.0.2.2.1.:._._.(.~.!.=.#.@.+.Y S R Q K E C x q o i b 5 4 ),',2 9 f n B P *.7.f.R.$+N+V#O$e*%;I;                                                  ",
	"                                                                                        [ < 7 e m u t A z H G O V U ..` &.%.'.,.>.^.].}.}.[.[.    1.2.2.0.0.0.0.0.0.0.0.0.2.2.2.1.1.:._._.(.~.!.-.=.#.@.+.Y X S Q L K D C w q o i b 5 !,~,| 1 9 f n B J W ).f.R.$+N+V#O$e*%;I;                                                    ",
	"                                                                                        } } < 7 e m l t s z I H O N V U  .` &.%.'.,.>.>.^.].}.}.{,_.:.:.:.:.1.1.1.1.1.1.:.:.:._._.(.(.~.!.!.-.=.#.@.+.Y X S R L K E C x w p o h b 5 ],^,| 1 9 f n v J W ).f.R.$+2+1@[$/*c-I;                                                      ",
	"                                                                                          | } < 8 e d l u s A z H G O N V .. .` &.&.%.'.,.>.>.^./,(,~.~.(.(.(.(.(.(.(.(.(.(.~.~.!.!.-.-.=.#.#.@.+.Y X S R Q L E D C w q p i h a 5 _,:,| 2 9 f n v J W ).f.J.V.2+1@[$/*c-%;I;                                                      ",
	"                                                                                            | } [ 8 7 d m u t s z I H G O N V U .. .` &.&.%.'.'.,.,.F&<,-.!.!.!.!.!.!.!.-.-.-.=.=.=.#.@.@.+.Y X X S R Q L K D C x w p o i b a [,},} | 2 9 f n v J W ).7.J.V.2+1@V#O$e*%;I;                                                        ",
	"                                                                                              1 | [ < 7 e m l u t A z I H G O N V U .... .` ` &.&.%.%.|,1,#.#.#.#.#.#.#.#.#.@.@.@.+.+.Y X X S R Q L K E D C x w q p i h b 5 2,3,} 1 2 0 f n v J W ).7.J.V.2+N+V#O$e*%;I;                                                          ",
	"                                                                                              2 1 | } < 8 e d m l t s A z I H G O N N V U U .. . . .` ` ` 4,5,6,+.+.+.+.+.Y Y Y X X S S R Q Q L K E D C x w q p o i b 7,8,9,[ | 1 2 0 g n B J W ).7.J.V.$+N+V#O$e*%;I;                                                            ",
	"                                                                                                2 2 1 } [ < 7 e d m u t s A z I I H G O O N V V U U U ..........0,a,b,X S S S R R Q Q L L K E E D C x w q p o i c,d,e,8 < } | 2 9 0 g n B P W ).7.J.V.$+N+V#O$e*c-I;                                                              ",
	"                                                                                                  9 2 1 | } < 8 7 e d m l u t s A z I I H G G O O N N N V V V V V V V f,g,h,i,j,k,L E E D D C x w w q l,m,n,o,d 7 8 < [ } 1 2 0 f g v B P W ).f.J.V.2+N+V#O$/*c-I;p,                                                              ",
	"                                                                                                    9 9 2 1 } [ < 8 7 e d m l u t s s A z z I I H H G G G G O O O O O G G G G H H H q,r,r,s,t,t,u,v,l m m d e 8 < [ } | 2 9 0 g n v J P *.).f.J.V.2+N+V#O$/*c-I;I;                                                                ",
	"                                                                                                      0 0 9 2 | } [ < 8 7 e d m l l u t t s A A A z z z I I I I I I I I I I z z z A A s s t u u l m d e 7 8 < [ } | 1 2 0 f g v B J W *.7.f.R.V.2+N+V#O$/*c-I;I;                                                                  ",
	"                                                                                                          0 0 9 1 | } [ < 8 7 7 e d m m l u u t t t s s s s A A A A A A s s s s t t u u l l m d e e 7 8 < [ } | 1 2 9 0 g n v J P W ).7.J.R.$+2+1@V#O$e*c-I;I;                                                                    ",
	"                                                                                                            f f 0 9 1 | | } [ < 8 7 7 e d d m m l l l u u u u u u u u u u u l l l m m d d e e 7 8 < < [ } | 1 2 9 0 f n v B J W *.).f.J.V.$+N+1@[$O$e*c-%;                                                                        ",
	"                                                                                                              g g f 0 9 2 1 | } [ [ < 8 8 7 7 e e d d d d m m m m m m m d d d d e e e 7 8 8 < < [ } | 1 1 2 9 0 f n v B J P W ).7.f.R.V.2+N+1@[$O$e*%;I;                                                                          ",
	"                                                                                                                n n g f 0 9 2 2 1 | } } [ [ < < 8 8 8 7 7 7 7 7 7 7 7 7 7 7 7 8 8 8 < < [ [ } | | 1 2 9 0 f g n v B J P W *.7.f.J.R.$+2+1@V#[$/*e*%;I;                                                                            ",
	"                                                                                                                  v v n g f f 0 9 2 2 1 | | } } } [ [ [ < < < < < < < < < [ [ [ [ } } | | 1 1 2 9 0 0 f g n v B J P W *.).7.J.R.V.$+N+1@[$O$/*c-%;I;                                                                              ",
	"                                                                                                                    B B B v n g f f 0 9 9 2 2 1 1 1 | | | | | | | | | | | | | 1 1 1 2 2 9 9 0 0 f g n n v B J P W *.).7.f.R.V.$+2+1@V#[$/*e*c-%;                                                                                  ",
	"                                                                                                                        J J B v v n g g f f 0 0 9 9 9 9 2 2 2 2 2 2 2 2 2 2 9 9 9 0 0 f f g g n v v B J P P W *.).7.f.J.V.$+2+N+1@[$O$/*c-%;%;                                                                                    ",
	"                                                                                                                            P P J B B v v n n g g g f f f f 0 0 0 0 0 f f f f f g g n n n v B B J P P W *.).7.f.J.R.V.$+2+N+1@V#[$/*e*c-%;                                                                                        ",
	"                                                                                                                                W W P P J J B B v v v n n n n n n n n n n n v v v B B B J J P W W *.).).7.f.J.R.V.$+2+N+1@V#[$O$e*c-c-                                                                                            ",
	"                                                                                                                                    *.*.W W P P P J J J J B B B B B B B J J J J P P P W W *.*.).7.7.f.J.J.R.V.$+2+N+1@V#[$O$/*e*c-                                                                                                ",
	"                                                                                                                                      ).).).).*.*.*.*.W W W W W W W W W W W W *.*.*.).).7.7.f.f.J.R.R.V.$+2+N+N+1@V#[$O$/*e*c-                                                                                                    ",
	"                                                                                                                                            7.7.7.7.7.7.7.).).).).).).).).7.7.7.7.f.f.J.J.R.R.V.V.$+2+2+N+1@V#[$O$/*/*e*c-                                                                                                        ",
	"                                                                                                                                                  J.J.J.J.J.J.J.J.J.J.J.J.J.J.R.R.R.V.V.V.$+$+2+N+N+1@V#V#[$O$/*/*e*                                                                                                              ",
	"                                                                                                                                                          R.R.V.V.V.V.V.V.$+$+$+$+2+2+2+N+N+1@1@V#[$[$O$O$/*                                                                                                                      ",
	"                                                                                                                                                                    2+2+2+2+2+N+N+N+1@1@V#V#V#[$                                                                                                                                  ",
	"                                                                                                                                                                                                                                                                                                                                  ",
	"                                                                                                                                                                                                                                                                                                                                  ",
	"                                                                                                                                                                                                                                                                                                                                  ",
	"   	                                                                                                                                                                                                                                                                                                                               ",
	"                                                                                                                                                                                                                                                                                                                                  "
};


PreviewWindow::PreviewWindow( QWidget* parent, const char* name )
			  : QWidget( parent, name )
{
	// set up the config for this application
	config = kapp->config();

	// Indicates that there are 0 tabs so far
	numTabs = 0;

	// set the current game to nothing
	currentGame = (Game*) NULL;

    // Create a layout to position the widgets
	QGridLayout* topLayout = new QGridLayout( this, 10 );

    // Create a tabwidget that contains snapshots and labels
    tabs = new QTabWidget( this );
    tabs->setMargin( 4 );
	topLayout->addWidget( tabs, 0, 0 );

	// create a preview widget which will display game snapshot images
	snapshot = new Preview( tabs );

	// create a preview widget which will display game label images
	label = new Preview( tabs );

	// create an html widget which will display game manuals
	html = new QTextBrowser( tabs );

    // add the tabs to the tab widget
    tabs->addTab( snapshot, i18n("Snapshot") );
    tabs->addTab( label, i18n("Label") );
    tabs->addTab( html, i18n("Manual") );
	numTabs += 3;

	// change the contents when a tab changes
    connect(tabs, SIGNAL(currentChanged(QWidget *)), this, SLOT(slotTabChanged(QWidget *)));

	// set up timer for resize events so we aren't overwhelmed with too many resizes
	// only do a resize on the LAST resize event (within a certain amount of time)
	resizeTimer = new QTimer( this );
	connect( resizeTimer, SIGNAL(timeout()), this, SLOT(slotSizeChanged()) );

	// create the static image which represents when no preview was found
	noPreview = new QPixmap( no_preview_xpm );
}


PreviewWindow::~PreviewWindow( void )
{
	if( resizeTimer )
		delete resizeTimer;

	if( noPreview )
		delete noPreview;
}


void PreviewWindow::slotSetCurrentGame( Game* g )
{
	currentGame = g;

	// now make sure the game preview is updated
	slotTabChanged( (QWidget*) 0 );
}


void PreviewWindow::slotTabChanged( QWidget* )
{
	// determine what the current tab is and update its display
	QString label = tabs->label( tabs->currentPageIndex() );

	if( label == "Snapshot")
		doSnapshot();
	else if( label == "Label")
		doLabel();
	else if( label == "Manual")
		doManual();
}


void PreviewWindow::doSnapshot( void )
{
	if( !currentGame )
		return;

	config->setGroup( "Emulator Defaults" );
	QString snapFile = config->readEntry( "SnapshotDir" );
	if( snapFile.length() == 0 )
	{
		snapshot->setPixmap( *noPreview );
		return;
	}
	else if( !snapFile.endsWith( "/" ) )
		snapFile += "/";

	snapFile += currentGame->md5() + ".png";
	if( !QFile::exists( snapFile ) )
	{
		snapshot->setPixmap( *noPreview );
		return;
	}

	QImage p1( snapFile );
	QPixmap pm;

	// If the snapshot is larger than the snapshot frame, then resize it
	int widthLimit  = snapshot->contentsRect().width() - 8;
	int heightLimit = snapshot->contentsRect().height() - 8;

	if( (p1.width() > widthLimit) || (p1.height() > heightLimit) )
	{
		// Determine which dimension is bigger than its supposed to be
		float widthFactor  = float(widthLimit) / float(p1.width());
		float heightFactor = float(heightLimit) / float(p1.height());

		if( widthFactor < heightFactor )
		{
			int width  = int( float(p1.width()) * widthFactor );
			int height = int( float(p1.height()) * widthFactor );
			p1 = p1.smoothScale( width, height );
		}
		else
		{
			int width  = int( float(p1.width()) * heightFactor );
			int height = int( float(p1.height()) * heightFactor );
			p1 = p1.smoothScale( width, height );
		}
	}

	// now convert back to a pixmap for viewing
	if( p1.isNull() )
		return;
	pm.convertFromImage( p1 );
	snapshot->setPixmap( pm );
}


void PreviewWindow::doLabel( void )
{
	if( !currentGame )
		return;

	config->setGroup( "Emulator Defaults" );
	QString labelFile = config->readEntry( "LabelDir" );
	if( labelFile.length() == 0 )
	{
		label->setPixmap( *noPreview );
		return;
	}
	else if( !labelFile.endsWith( "/" ) )
		labelFile += "/";

	labelFile += currentGame->md5() + ".jpg";
	if( !QFile::exists( labelFile ) )
	{
		label->setPixmap( *noPreview );
		return;
	}

	QImage p1( labelFile );
	QPixmap pm;

	// If the label is larger than the label frame, then resize it
	int widthLimit  = label->frameRect().width() - 8;
	int heightLimit = label->frameRect().height() - 8;

	if( (p1.width() > widthLimit) || (p1.height() > heightLimit) )
	{
		// Determine which dimension is bigger than its supposed to be
		float widthFactor  = float(widthLimit) / float(p1.width());
		float heightFactor = float(heightLimit) / float(p1.height());

		if( widthFactor < heightFactor )
		{
			int width  = int( float(p1.width()) * widthFactor );
			int height = int( float(p1.height()) * widthFactor );
			p1 = p1.smoothScale( width, height );
		}
		else
		{
			int width  = int( float(p1.width()) * heightFactor );
			int height = int( float(p1.height()) * heightFactor );
			p1 = p1.smoothScale( width, height );
		}
	}

	// now convert back to a pixmap for viewing
	if( p1.isNull() )
		return;

	pm.convertFromImage( p1 );
	label->setPixmap( pm );
}


void PreviewWindow::doManual( void )
{
	if( !currentGame )
		return;

	config->setGroup( "Emulator Defaults" );
	QString manual = config->readEntry("ManualDir");
	if( manual.length() == 0 )
	{
		html->setText( "<h2>No manual available.</h2>" );
		return;
	}
	else if( !manual.endsWith( "/" ) )
		manual += "/";

	manual += currentGame->md5() + ".html";

	// check to see if the manual is actually there
	if( QFile::exists( manual ) )
		html->setSource( manual );
	else
		html->setText( "<h2>No manual available.</h2>" );
}


void PreviewWindow::slotChangeTab( int direction )
{
	int index = tabs->currentPageIndex();

	if( direction == 1 )	// move to the right
	{
		if( index+1 < numTabs )
			tabs->setCurrentPage( index + 1 );
	}
	else if( direction == 0 )	// move to the left
	{
		if( index-1 >= 0 )
			tabs->setCurrentPage( index - 1 );
	}
}


void PreviewWindow::slotSizeChanged( void )
{
	slotTabChanged( (QWidget*) 0 );
}


void PreviewWindow::resizeEvent( QResizeEvent* )
{
	resizeTimer->start( 50, TRUE );
}
