/***************************************************************************
 *   Copyright (C) 2004 by Stephen Anthony                                 *
 *   stephena@users.sourceforge.net                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef QINDEXEDITEM_H
#define QINDEXEDITEM_H

#include <qlistview.h>


/** This class is used to extend the functionality of a QListViewItem.  Normally,
	a QListViewItem has no associated index.  This makes it more difficult to
	deal with such items when they interact with vectors.  This class adds an
	index variable to a QListViewItem.
*/
class QIndexedItem : public QListViewItem
{
	public:
		/** Constructor which calls the QListViewItem constructor. */
		QIndexedItem( QListView *parent, int index, const char *v1,
					  const char *v2, const char *v3 );

		/** Destructor. */
		~QIndexedItem();

		/** Sets the index of this listview item. */
		void setIndex( const int index );

		/** Returns the index of this listview item. */
		int getIndex() const;

	private:
		int index;
};

#endif
