/***************************************************************************
 *   Copyright (C) 2004 by Stephen Anthony                                 *
 *   stephena@users.sourceforge.net                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SETUP_H
#define SETUP_H

#include <qdialog.h>
#include <kconfig.h>

#include "setupdlg.h"

/**
  *@author Stephen Anthony
  */

class Setup : public SetupDlg
{
	Q_OBJECT
	public:
		Setup( QWidget *parent = 0, const char *name = 0 );
		~Setup( void );
	
		/** reads the emulator defaults */
		void readConfig( void );

		/** saves the current emulator settings as default */
		void writeConfig( void );

	private slots:
		void slotOKClicked( void );
		void slotDefaultsClicked( void );
		void slotBinaryClicked( void );
		void slotDocDirClicked( void );
		void slotRomDirClicked( void );
		void slotSnapShotDirClicked( void );
		void slotLabelDirClicked( void );
		void slotManualDirClicked( void );

	private:
		/** the configuration object of the application */
		KConfig* config;
};

#endif
